{ COPYINC.PAS    Author: Trevor J Carlsen
                         PO Box 568
                         Port Hedland  6721
                         Western Australia


SYNTAX:    copyinc filename

where filename is the name of a text file you wish to create that will be used
as an include file in a Turbo Pascal program.

This program creates a text file in the format

      const
        RegStr  ='This program is an unregistered copy';
        CodeStr =
        #125#34#139#139#74#71#94#61#44#78#65#155#158#132#62#136#141#140#84+
        #34#155#63#38#46#89#84#93#57#153#51#83#112#72#36#138#93;
        keyval  = 1234567890;

The text file that was used by COPYINC to create the above include file would
have looked like this

p:\prog\freeload.inc
This program is an unregistered copy
RegStr  =
CodeStr =
1234567890

Here is another example.  This was the include file -

      const
        ChkStr     : string ='This program is registered to';
        CodeChkStr : string =
        #32#153#90#34#133#140#42#129#150#50#81#36#83#36#133#154#52#76#75+
        #129#45#93#77#44#83#149#157#71#95#225;
        keyval  = 1234567890;

and the text file used by COPYINC -

p:\prog\registed.inc
This program is registered to
ChkStr     : string =
CodeChkStr : string =
1234567890


The text file must always consist of five lines that are
 1.  The name of the include file to be created.
 2.  The plain text.
 3.  The name of the plain text constant along with its syntax.
 4.  The name and syntax of the coded text constant.
 5.  A key value.  Any number in the longint range is valid.


}

uses
  endecode;  { my encryption unit }

const
  hash   = '#';
var
  f      : text;
  params : text;
  keyval : longint;
  notice,
  fname,
  CodeStr,
  CodeVar,
  PlainVar: string;
  x      : word;

begin
  assign(params,ParamStr(1));
  reset(params);
  readln(params,fname);
  readln(params,notice);
  readln(params,PlainVar);
  readln(params,CodeVar);
  readln(params,keyval);
  CodeStr := EncryptStr(keyval,notice);
  notice := '  '+ PlainVar + #39 + notice + #39#59;
  assign(f,fname);
  rewrite(f);
  writeln(f,'const');
  writeln(f,notice);
  writeln(f,'  ',CodeVar);
  write(f,'  ');
  for x := 1 to length(CodeStr) do begin
    if x mod 20 = 0 then begin
      writeln(f,'+');
      write(f,'  ');
    end;
    write(f,'#',ord(CodeStr[x]));
  end;
  writeln(f,';');
  writeln(f,'  keyval  = ',keyval,#59);
  writeln(f);
  close(f);
end.

